<template>
    <v-form ref="form" v-model="valid" class="mt-3">
        <v-row justify="center">

            <v-col cols="6">
                <v-text-field
                v-model="user.firstName"
                label="Enter first name"
                :rules="rules"
                hide-details
                outlined
                :error="firstNameError"
                />
            </v-col>
            <v-col cols="6">
                <v-text-field
                v-model="user.lastName"
                label="Enter last name"
                :rules="rules"
                hide-details
                outlined
                :error="lastNameError"
                />
            </v-col>
            <v-col cols="12">
                <v-text-field
                v-model="user.phone"
                label="Enter phone number"
                :rules="rules"
                hide-details
                outlined
                :error="phoneError"
                />
            </v-col>
            <v-col cols="12">
                <v-text-field
                v-model="user.email"
                label="Enter email"
                :rules="rulesEmail"
                hide-details
                outlined
                :error="emailError"
                />
            </v-col>
            <v-col cols="12">
                <v-text-field
                v-model="user.password"
                label="Enter password"
                type="password"
                :rules="rules"
                hide-details
                outlined
                :error="passError"
                @keyup.enter="signUp"
                />
            </v-col>
            <v-col
                v-if="authErrorMessages !== null"
                cols="12"
                xs="12"
                md="12"
            >
                <p style="color: red">{{ authErrorMessages }}</p>
            </v-col>
            <v-col cols="12">
                <v-btn
                :loading="loading"
                outlined
                block
                large
                color="primary"
                @click="signUp"
                >Sign up</v-btn
                >
            </v-col>
            <v-col cols="12">
                <p class="body-1">
                Already have an account? <a href="/login">Log in</a>
                </p>
            </v-col>
        </v-row>
    </v-form>
</template>

<script>
import { mapState, mapGetters } from 'vuex'

export default {
  name: 'SignUp',
  data() {
    return {
      rules: [
        value => !!value || 'Required.',
        value => (value && value.length >= 3) || 'Min 3 characters'
      ],
      rulesEmail: [
        value => !!value || 'Required.',
        value => (value && value.length >= 3) || 'Min 3 characters',
        value => {
          const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
          return pattern.test(value) || 'Invalid e-mail.'
        }
      ],
      emailError: false,
      passError: false,
      firstNameError: false,
      lastNameError: false,
      phoneError: false,
      valid: false,
      user: {
        email: null,
        password: null,
        firstName: null,
        lastName: null,
        phone: null
      },
      loading: false
    }
  },
  computed: {
    ...mapState('authentication', ['authErrorMessages']),
    ...mapGetters('authentication', ['isUserLoggedIn'])
  },
  mounted() {
    if (this.isUserLoggedIn) {
      this.$router.push('/dashboard')
    }
  },
  beforeDestroy() {
    this.$store.dispatch('authentication/clearAuthErrors')
  },
  methods: {
    signUp() {
      if (this.$refs.form.validate()) {
        this.loading = true
        this.$store
          .dispatch('authentication/signUp', this.user)
          .then(() => (this.loading = false))
          .catch(() => (this.loading = false))
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.page-wrapper {
  display: flex;
  justify-content: center;
  flex-direction: column;
  align-items: center;
  .text-or {
    font-size: 18px;
    color: grey;
  }
}
</style>
